/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   ft_radix.c                                         :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: cchauvet <cchauvet@student.42angouleme.fr  +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2022/11/15 18:16:31 by cchauvet          #+#    #+#             */
/*   Updated: 2022/11/30 20:06:39 by cchauvet         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "pushswap.h"

void	ft_radix_sort(int *tab_a, int *tab_b)
{
	int	tab_index;
	int	loop_index;
	int	shift;

	while (!ft_is_sorted(tab_a))
	{
		tab_index = ft_tablen(tab_a) - 1;
		loop_index = tab_index;
		shift = ft_bit_finder_right(ft_get_bit_min(tab_a), 1);
		while (loop_index > 0 && !ft_is_sorted(tab_a))
		{
			if (tab_a[tab_index] >> shift & 1)
			{	
				ft_pb(tab_a, tab_b);
				tab_index--;
			}
			else
				ft_ra(tab_a);
			loop_index--;
		}
		while (tab_b[0] != -1)
			ft_pa(tab_a, tab_b);
		tab_index = ft_tablen(tab_a);
		while (--tab_index >= 0 && !ft_is_sorted(tab_a))
			tab_a[tab_index] = tab_a[tab_index] << 1;
	}
	free(tab_a);
	free(tab_b);
}
